(function(){var $wnd = window;var $doc = $wnd.document;var $moduleName, $moduleBase;var _,Em='com.google.gwt.core.client.',Fm='com.google.gwt.lang.',an='com.google.gwt.sample.hello.client.',bn='com.google.gwt.user.client.',cn='com.google.gwt.user.client.impl.',dn='com.google.gwt.user.client.ui.',en='com.google.gwt.user.client.ui.impl.',fn='java.lang.',gn='java.util.';function Dm(){}
function oi(a){return this===a;}
function pi(){return bj(this);}
function mi(){}
_=mi.prototype={};_.q=oi;_.C=pi;_.Db=fn+'Object';_.Cb=0;var p=null;function s(a){return a==null?0:a.$H?a.$H:(a.$H=u());}
function t(a){return a==null?0:a.$H?a.$H:(a.$H=u());}
function u(){return ++v;}
var v=0;function y(b,a){if(!kb(a,1)){return false;}return A(b,jb(a,1));}
function z(a){return s(a);}
function B(a){return y(this,a);}
function A(a,b){return a===b;}
function C(){return z(this);}
function w(){}
_=w.prototype=new mi();_.q=B;_.C=C;_.Db=Em+'JavaScriptObject';_.Cb=5;function E(c,a,d,b,e){c.a=a;c.b=b;e;c.Cb=d;return c;}
function ab(a,b,c){return a[b]=c;}
function bb(b,a){return b[a];}
function cb(a){return a.length;}
function eb(e,d,c,b,a){return db(e,d,c,b,0,cb(b),a);}
function db(j,i,g,c,e,a,b){var d,f,h;if((f=bb(c,e))<0){throw new ki();}h=E(new D(),f,bb(i,e),bb(g,e),j);++e;if(e<a){j=j.yb(1);for(d=0;d<f;++d){ab(h,d,db(j,i,g,c,e,a,b));}}else{for(d=0;d<f;++d){ab(h,d,b);}}return h;}
function fb(a,b,c){if(c!==null&&a.b!=0&& !kb(c,a.b)){throw new xh();}return ab(a,b,c);}
function D(){}
_=D.prototype=new mi();_.Db=Fm+'Array';_.Cb=0;function ib(b,a){if(!b)return false;return !(!nb[b][a]);}
function jb(b,a){if(b!=null)ib(b.Cb,a)||mb();return b;}
function kb(b,a){if(b==null)return false;return ib(b.Cb,a);}
function mb(){throw new Ah();}
function lb(a){if(a!==null){throw new Ah();}return a;}
function ob(b,d){_=d.prototype;if(b&& !(b.Cb>=_.Cb)){var c=b.toString;for(var a in _){b[a]=_[a];}b.toString=c;}return b;}
var nb;function wb(b){var a;a=re(new ke(),'Click me',new sb());ge(Ff(),a);}
function rb(){}
_=rb.prototype=new mi();_.Db=an+'Hello';_.Cb=0;function ub(a){ed('Hello, AJAX');}
function sb(){}
_=sb.prototype=new mi();_.hb=ub;_.Db=an+'Hello$1';_.Cb=6;function yb(){yb=Dm;jc=Bk(new Ak());{fc=new pd();fc.ab();}}
function zb(b,a){yb();fc.h(b,a);}
function Ab(a,b){yb();return fc.i(a,b);}
function Bb(){yb();return fc.m('button');}
function Cb(){yb();return fc.m('div');}
function Eb(b,a,d){yb();var c;c=p;{Db(b,a,d);}}
function Db(b,a,c){yb();if(a===ic){if(ac(b)==8192){ic=null;}}c.gb(b);}
function Fb(b,a){yb();fc.r(b,a);}
function ac(a){yb();return fc.s(a);}
function bc(a){yb();fc.t(a);}
function cc(a,b){yb();return fc.u(a,b);}
function dc(a){yb();return fc.v(a);}
function ec(a){yb();return fc.x(a);}
function gc(a){yb();var b,c;c=true;if(jc.xb()>0){b=lb(jc.z(jc.xb()-1));if(!(c=null.Fb())){Fb(a,true);bc(a);}}return c;}
function hc(b,a){yb();fc.mb(b,a);}
function kc(a,b,c){yb();fc.rb(a,b,c);}
function lc(a,b){yb();fc.tb(a,b);}
function mc(a,b){yb();fc.ub(a,b);}
function nc(b,a,c){yb();fc.vb(b,a,c);}
function oc(a,b){yb();fc.wb(a,b);}
var fc=null,ic=null,jc;function rc(a){if(kb(a,3)){return Ab(this,jb(a,3));}return y(ob(this,pc),a);}
function sc(){return z(ob(this,pc));}
function pc(){}
_=pc.prototype=new w();_.q=rc;_.C=sc;_.Db=bn+'Element';_.Cb=7;function wc(a){return y(ob(this,tc),a);}
function xc(){return z(ob(this,tc));}
function tc(){}
_=tc.prototype=new w();_.q=wc;_.C=xc;_.Db=bn+'Event';_.Cb=8;function Dc(){Dc=Dm;Fc=Bk(new Ak());{Ec();}}
function Ec(){Dc();dd(new zc());}
var Fc;function Bc(){while((Dc(),Fc).xb()>0){lb((Dc(),Fc).z(0)).Fb();}}
function Cc(){return null;}
function zc(){}
_=zc.prototype=new mi();_.jb=Bc;_.kb=Cc;_.Db=bn+'Timer$1';_.Cb=9;function cd(){cd=Dm;fd=Bk(new Ak());nd=Bk(new Ak());{jd();}}
function dd(a){cd();Ck(fd,a);}
function ed(a){cd();$wnd.alert(a);}
function gd(){cd();var a,b;for(a=xj(fd);rj(a);){b=jb(sj(a),4);b.jb();}}
function hd(){cd();var a,b,c,d;d=null;for(a=xj(fd);rj(a);){b=jb(sj(a),4);c=b.kb();{d=c;}}return d;}
function id(){cd();var a,b;for(a=xj(nd);rj(a);){b=lb(sj(a));null.Fb();}}
function jd(){cd();__gwt_initHandlers(function(){md();},function(){return ld();},function(){kd();$wnd.onresize=null;$wnd.onbeforeclose=null;$wnd.onclose=null;});}
function kd(){cd();var a;a=p;{gd();}}
function ld(){cd();var a;a=p;{return hd();}}
function md(){cd();var a;a=p;{id();}}
var fd,nd;function zd(b,a){b.appendChild(a);}
function Ad(a){return $doc.createElement(a);}
function Bd(b,a){b.cancelBubble=a;}
function Cd(a){switch(a.type){case 'blur':return 4096;case 'change':return 1024;case 'click':return 1;case 'dblclick':return 2;case 'focus':return 2048;case 'keydown':return 128;case 'keypress':return 256;case 'keyup':return 512;case 'load':return 32768;case 'losecapture':return 8192;case 'mousedown':return 4;case 'mousemove':return 64;case 'mouseout':return 32;case 'mouseover':return 16;case 'mouseup':return 8;case 'scroll':return 16384;case 'error':return 65536;case 'mousewheel':return 131072;case 'DOMMouseScroll':return 131072;}}
function Dd(a,b){var c=a[b];return c==null?null:String(c);}
function Ed(a){return a.__eventBits||0;}
function Fd(b,a){b.removeChild(a);}
function ae(a,b,c){a[b]=c;}
function be(a,b){a.__listener=b;}
function ce(a,b){if(!b){b='';}a.innerHTML=b;}
function de(b,a,c){b.style[a]=c;}
function od(){}
_=od.prototype=new mi();_.h=zd;_.m=Ad;_.r=Bd;_.s=Cd;_.u=Dd;_.v=Ed;_.mb=Fd;_.rb=ae;_.tb=be;_.ub=ce;_.vb=de;_.Db=cn+'DOMImpl';_.Cb=0;function td(a,b){return a==b;}
function ud(a){a.preventDefault();}
function vd(a){var b=a.parentNode;if(b==null){return null;}if(b.nodeType!=1)b=null;return b||null;}
function wd(){$wnd.__dispatchCapturedMouseEvent=function(b){if($wnd.__dispatchCapturedEvent(b)){var a=$wnd.__captureElem;if(a&&a.__listener){Eb(b,a,a.__listener);b.stopPropagation();}}};$wnd.__dispatchCapturedEvent=function(a){if(!gc(a)){a.stopPropagation();a.preventDefault();return false;}return true;};$wnd.addEventListener('click',$wnd.__dispatchCapturedMouseEvent,true);$wnd.addEventListener('dblclick',$wnd.__dispatchCapturedMouseEvent,true);$wnd.addEventListener('mousedown',$wnd.__dispatchCapturedMouseEvent,true);$wnd.addEventListener('mouseup',$wnd.__dispatchCapturedMouseEvent,true);$wnd.addEventListener('mousemove',$wnd.__dispatchCapturedMouseEvent,true);$wnd.addEventListener('mousewheel',$wnd.__dispatchCapturedMouseEvent,true);$wnd.addEventListener('keydown',$wnd.__dispatchCapturedEvent,true);$wnd.addEventListener('keyup',$wnd.__dispatchCapturedEvent,true);$wnd.addEventListener('keypress',$wnd.__dispatchCapturedEvent,true);$wnd.__dispatchEvent=function(a){if(this.__listener)Eb(a,this,this.__listener);};$wnd.__captureElem=null;}
function xd(b,a){b.__eventBits=a;b.onclick=a&1?$wnd.__dispatchEvent:null;b.ondblclick=a&2?$wnd.__dispatchEvent:null;b.onmousedown=a&4?$wnd.__dispatchEvent:null;b.onmouseup=a&8?$wnd.__dispatchEvent:null;b.onmouseover=a&16?$wnd.__dispatchEvent:null;b.onmouseout=a&32?$wnd.__dispatchEvent:null;b.onmousemove=a&64?$wnd.__dispatchEvent:null;b.onkeydown=a&128?$wnd.__dispatchEvent:null;b.onkeypress=a&256?$wnd.__dispatchEvent:null;b.onkeyup=a&512?$wnd.__dispatchEvent:null;b.onchange=a&1024?$wnd.__dispatchEvent:null;b.onfocus=a&2048?$wnd.__dispatchEvent:null;b.onblur=a&4096?$wnd.__dispatchEvent:null;b.onlosecapture=a&8192?$wnd.__dispatchEvent:null;b.onscroll=a&16384?$wnd.__dispatchEvent:null;b.onload=a&32768?$wnd.__dispatchEvent:null;b.onerror=a&65536?$wnd.__dispatchEvent:null;b.onmousewheel=a&131072?$wnd.__dispatchEvent:null;}
function rd(){}
_=rd.prototype=new od();_.i=td;_.t=ud;_.x=vd;_.ab=wd;_.wb=xd;_.Db=cn+'DOMImplStandard';_.Cb=0;function pd(){}
_=pd.prototype=new rd();_.Db=cn+'DOMImplOpera';_.Cb=0;function ig(b,a){if(b.d!==null){b.qb(b.d,a);}b.d=a;}
function jg(b,a){ng(b.d,a);}
function kg(b,a){oc(b.d,a|dc(b.d));}
function lg(b){var a;a=cc(b,'className').zb();if(vi('',a)){a='gwt-nostyle';kc(b,'className',a);}return a;}
function mg(b,a){var c=b.parentNode;if(!c){return;}c.insertBefore(a,b);c.removeChild(b);}
function ng(a,b){if(a===null){throw ri(new qi(),'Null widget handle. If you are creating a composite, ensure that initWidget() has been called.');}b=b.zb();if(b.db()==0){throw ci(new bi(),'Style names cannot be empty');}lg(a);og(a,b);}
function og(c,f){var a=c.className;var h=a.indexOf(' ');if(h>=0){var g=a.substring(0,h);var e='',b=0;while(true){var d=a.indexOf(g,b);if(d== -1){e+=a.substring(b);break;}e+=a.substring(b,d);e+=f;b=d+g.length;}c.className=e;}else{c.className=f;}}
function gg(){}
_=gg.prototype=new mi();_.qb=mg;_.Db=dn+'UIObject';_.Cb=0;_.d=null;function bh(a){if(a.b){throw fi(new ei(),"Should only call onAttach when the widget is detached from the browser's document");}a.b=true;lc(a.d,a);}
function ch(a){if(!a.b){throw fi(new ei(),"Should only call onDetach when the widget is attached to the browser's document");}{a.b=false;lc(a.d,null);}}
function dh(a){if(a.c!==null){af(a.c,a);}else if(a.c!==null){throw fi(new ei(),"This widget's parent does not implement HasWidgets");}}
function eh(b,a){if(b.b){lc(b.d,null);}ig(b,a);if(b.b){lc(a,b);}}
function fh(c,b){var a;a=c.c;c.c=b;if(b===null){if(a!==null&&a.b){c.ib();}}else if(b.b){c.fb();}}
function gh(){bh(this);}
function hh(a){}
function ih(){ch(this);}
function jh(a){eh(this,a);}
function pg(){}
_=pg.prototype=new gg();_.fb=gh;_.gb=hh;_.ib=ih;_.sb=jh;_.Db=dn+'Widget';_.Cb=10;_.b=false;_.c=null;function qf(b,c,a){dh(c);if(a!==null){zb(a,c.d);}fh(c,b);}
function sf(b,c){var a;if(c.c!==b){throw ci(new bi(),'w is not a child of this panel');}a=c.d;fh(c,null);hc(ec(a),a);}
function tf(c){var a,b;bh(c);for(b=c.bb();ug(b);){a=vg(b);a.fb();}}
function uf(c){var a,b;ch(c);for(b=c.bb();ug(b);){a=vg(b);a.ib();}}
function vf(){tf(this);}
function wf(){uf(this);}
function pf(){}
_=pf.prototype=new pg();_.fb=vf;_.ib=wf;_.Db=dn+'Panel';_.Cb=11;function Ae(a){a.a=yg(new qg(),a);}
function Be(a){Ae(a);return a;}
function Ce(b,c,a){return Fe(b,c,a,b.a.b);}
function Ee(b,a){return Bg(b.a,a);}
function Fe(d,e,b,a){var c;if(a<0||a>d.a.b){throw new hi();}c=Ee(d,e);if(c==(-1)){dh(e);}else{af(d,e);if(c<a){a--;}}qf(d,e,b);Cg(d.a,e,a);return a;}
function af(a,b){if(!Ag(a.a,b)){return false;}ie(a,b);Fg(a.a,b);return true;}
function bf(){return Dg(this.a);}
function ze(){}
_=ze.prototype=new pf();_.bb=bf;_.Db=dn+'ComplexPanel';_.Cb=12;function fe(a){Be(a);a.sb(Cb());nc(a.d,'position','relative');nc(a.d,'overflow','hidden');return a;}
function ge(a,b){Ce(a,b,a.d);}
function ie(a,b){sf(a,b);je(b.d);}
function je(a){nc(a,'left','');nc(a,'top','');nc(a,'position','static');}
function ee(){}
_=ee.prototype=new ze();_.Db=dn+'AbsolutePanel';_.Cb=13;function ff(){ff=Dm;th(),vh;}
function df(b,a){th(),vh;gf(b,a);return b;}
function ef(b,a){if(b.a===null){b.a=ve(new ue());}Ck(b.a,a);}
function gf(b,a){eh(b,a);kg(b,7041);}
function hf(a){switch(ac(a)){case 1:if(this.a!==null){xe(this.a,this);}break;case 4096:case 2048:break;case 128:case 512:case 256:break;}}
function jf(a){gf(this,a);}
function cf(){}
_=cf.prototype=new pg();_.gb=hf;_.sb=jf;_.Db=dn+'FocusWidget';_.Cb=14;_.a=null;function me(b,a){df(b,a);return b;}
function oe(b,a){mc(b.d,a);}
function le(){}
_=le.prototype=new cf();_.Db=dn+'ButtonBase';_.Cb=15;function pe(a){me(a,Bb());te(a.d);jg(a,'gwt-Button');return a;}
function qe(b,a){pe(b);oe(b,a);return b;}
function re(c,a,b){qe(c,a);ef(c,b);return c;}
function te(b){ff();if(b.type=='submit'){try{b.setAttribute('type','button');}catch(a){}}}
function ke(){}
_=ke.prototype=new le();_.Db=dn+'Button';_.Cb=16;function jj(d,a,b){var c;while(a.B()){c=a.eb();if(b===null?c===null:b.q(c)){return a;}}return null;}
function lj(a){throw gj(new fj(),'add');}
function mj(b){var a;a=jj(this,this.bb(),b);return a!==null;}
function ij(){}
_=ij.prototype=new mi();_.g=lj;_.k=mj;_.Db=gn+'AbstractCollection';_.Cb=0;function xj(a){return pj(new oj(),a);}
function yj(b,a){throw gj(new fj(),'add');}
function zj(a){this.f(this.xb(),a);return true;}
function Aj(e){var a,b,c,d,f;if(e===this){return true;}if(!kb(e,12)){return false;}f=jb(e,12);if(this.xb()!=f.xb()){return false;}c=xj(this);d=f.bb();while(rj(c)){a=sj(c);b=sj(d);if(!(a===null?b===null:a.q(b))){return false;}}return true;}
function Bj(){var a,b,c,d;c=1;a=31;b=xj(this);while(rj(b)){d=sj(b);c=31*c+(d===null?0:d.C());}return c;}
function Cj(){return xj(this);}
function Dj(a){throw gj(new fj(),'remove');}
function nj(){}
_=nj.prototype=new ij();_.f=yj;_.g=zj;_.q=Aj;_.C=Bj;_.bb=Cj;_.ob=Dj;_.Db=gn+'AbstractList';_.Cb=17;function Bk(a){a.F();return a;}
function Ck(b,a){b.f(b.xb(),a);return true;}
function Ek(b,a){return b.D(a,0);}
function Fk(c,a){var b;b=c.z(a);c.nb(a,a+1);return b;}
function al(c,d){var a=this.a;var b=this.b;var e=this.c;if(c+e==b){a[b]=d;this.b++;return;}if(c==0){a[--this.c]=d;return;}this.Ab(c);a.splice(c+e,0,d);this.b++;}
function bl(a){return Ck(this,a);}
function cl(a){return Ek(this,a)!=(-1);}
function dl(a,b){return a===null?b===null:a.q(b);}
function el(a){this.Bb(a);var b=this.c;return this.a[a+b];}
function fl(e,d){var a=this.a;var f=this.c;var c=d+f;var b=this.b;while(c<b){if(dl(a[c],e)){return c-f;}++c;}return -1;}
function gl(a){throw ii(new hi(),'Size: '+this.xb()+' Index: '+a);}
function hl(){this.a=new Array();var a=1000000000;this.c=a;this.b=a;}
function jl(a){return Fk(this,a);}
function il(c,g){this.Ab(c);this.Ab(g);var a=this.a;var f=this.c;var b=this.b;if(c==0){for(var d=f;d<g+f;d++){delete a[d];}this.c+=g-c;}else if(g+f==b){for(var d=c+f;d<b;d++){delete a[d];}this.b=c+f;}else{var e=g-c;a.splice(c+f,e);this.b-=e;}}
function kl(){return this.b-this.c;}
function ml(b){var a=this.b;var c=this.c;if(b<0||b+c>=a){this.E(b);}}
function ll(b){var a=this.b;var c=this.c;if(b<0||b+c>a){this.E(b);}}
function Ak(){}
_=Ak.prototype=new nj();_.f=al;_.g=bl;_.k=cl;_.z=el;_.D=fl;_.E=gl;_.F=hl;_.ob=jl;_.nb=il;_.xb=kl;_.Bb=ml;_.Ab=ll;_.Db=gn+'ArrayList';_.Cb=18;_.a=null;_.b=0;_.c=0;function ve(a){Bk(a);return a;}
function xe(d,c){var a,b;for(a=xj(d);rj(a);){b=jb(sj(a),5);b.hb(c);}}
function ue(){}
_=ue.prototype=new Ak();_.Db=dn+'ClickListenerCollection';_.Cb=19;function Df(){Df=Dm;cg=hm(new pl());}
function Cf(b,a){Df();fe(b);if(a===null){a=Ef();}b.sb(a);tf(b);return b;}
function Ff(){Df();return ag(null);}
function ag(c){Df();var a,b;b=jb(cg.A(c),6);if(b!==null){return b;}a=null;if(cg.a==0){bg();}cg.lb(c,b=Cf(new xf(),a));return b;}
function Ef(){Df();return $doc.body;}
function bg(){Df();dd(new yf());}
function xf(){}
_=xf.prototype=new ee();_.Db=dn+'RootPanel';_.Cb=20;var cg;function Af(){var a,b;for(b=xj(km((Df(),cg)));rj(b);){a=jb(sj(b),6);if(a.b){uf(a);}}}
function Bf(){return null;}
function yf(){}
_=yf.prototype=new mi();_.jb=Af;_.kb=Bf;_.Db=dn+'RootPanel$1';_.Cb=21;function yg(b,a){b.a=eb('[Lcom.google.gwt.user.client.ui.Widget;',[0],[8],[4],null);return b;}
function Ag(a,b){return Bg(a,b)!=(-1);}
function Bg(b,c){var a;for(a=0;a<b.b;++a){if(b.a[a]===c){return a;}}return (-1);}
function Cg(d,e,a){var b,c;if(a<0||a>d.b){throw new hi();}if(d.b==d.a.a){c=eb('[Lcom.google.gwt.user.client.ui.Widget;',[0],[8],[d.a.a*2],null);for(b=0;b<d.a.a;++b){fb(c,b,d.a[b]);}d.a=c;}++d.b;for(b=d.b-1;b>a;--b){fb(d.a,b,d.a[b-1]);}fb(d.a,a,e);}
function Dg(a){return sg(new rg(),a);}
function Eg(c,b){var a;if(b<0||b>=c.b){throw new hi();}--c.b;for(a=b;a<c.b;++a){fb(c.a,a,c.a[a+1]);}fb(c.a,c.b,null);}
function Fg(b,c){var a;a=Bg(b,c);if(a==(-1)){throw new zm();}Eg(b,a);}
function qg(){}
_=qg.prototype=new mi();_.Db=dn+'WidgetCollection';_.Cb=0;_.a=null;_.b=0;function sg(b,a){b.b=a;return b;}
function ug(a){return a.a<a.b.b-1;}
function vg(a){if(a.a>=a.b.b){throw new zm();}return a.b.a[++a.a];}
function wg(){return ug(this);}
function xg(){return vg(this);}
function rg(){}
_=rg.prototype=new mi();_.B=wg;_.eb=xg;_.Db=dn+'WidgetCollection$WidgetIterator';_.Cb=0;_.a=(-1);function th(){th=Dm;uh=nh(new lh());vh=uh!==null?sh(new kh()):uh;}
function sh(a){th();return a;}
function kh(){}
_=kh.prototype=new mi();_.Db=en+'FocusImpl';_.Cb=0;var uh,vh;function mh(a){a.l();a.n();a.o();}
function nh(a){sh(a);mh(a);return a;}
function ph(){return function(a){if(this.parentNode.onblur){this.parentNode.onblur(a);}};}
function qh(){return function(a){if(this.parentNode.onfocus){this.parentNode.onfocus(a);}};}
function rh(){return function(){this.firstChild.focus();};}
function lh(){}
_=lh.prototype=new kh();_.l=ph;_.n=qh;_.o=rh;_.Db=en+'FocusImplOld';_.Cb=0;function dj(b,a){a;return b;}
function cj(){}
_=cj.prototype=new mi();_.Db=fn+'Throwable';_.Cb=1;function Fh(b,a){dj(b,a);return b;}
function Eh(){}
_=Eh.prototype=new cj();_.Db=fn+'Exception';_.Cb=2;function ri(b,a){Fh(b,a);return b;}
function qi(){}
_=qi.prototype=new Eh();_.Db=fn+'RuntimeException';_.Cb=3;function xh(){}
_=xh.prototype=new qi();_.Db=fn+'ArrayStoreException';_.Cb=22;function Ah(){}
_=Ah.prototype=new qi();_.Db=fn+'ClassCastException';_.Cb=23;function ci(b,a){ri(b,a);return b;}
function bi(){}
_=bi.prototype=new qi();_.Db=fn+'IllegalArgumentException';_.Cb=24;function fi(b,a){ri(b,a);return b;}
function ei(){}
_=ei.prototype=new qi();_.Db=fn+'IllegalStateException';_.Cb=25;function ii(b,a){ri(b,a);return b;}
function hi(){}
_=hi.prototype=new qi();_.Db=fn+'IndexOutOfBoundsException';_.Cb=26;function ki(){}
_=ki.prototype=new qi();_.Db=fn+'NegativeArraySizeException';_.Cb=27;function ui(){ui=Dm;{yi();}}
function vi(b,a){if(!kb(a,11))return false;return wi(b,a);}
function wi(a,b){ui();return a.toString()==b;}
function xi(d){ui();var a=Ai[':'+d];if(a){return a;}a=0;var c=d.length;var b=c;while(--b>=0){a<<=1;a+=d.charCodeAt(b);}Ai[':'+d]=a;return a;}
function yi(){ui();Ai={};}
function zi(a){return vi(this,a);}
function Bi(){return xi(this);}
function Ci(){return this.length;}
function Di(a){return this.substr(a,this.length-a);}
function Ei(){var a=this.replace(/^(\s*)/,'');var b=a.replace(/\s*$/,'');return b;}
_=String.prototype;_.q=zi;_.C=Bi;_.db=Ci;_.yb=Di;_.zb=Ei;_.Db=fn+'String';_.Cb=28;var Ai=null;function bj(a){return t(a);}
function gj(b,a){ri(b,a);return b;}
function fj(){}
_=fj.prototype=new qi();_.Db=fn+'UnsupportedOperationException';_.Cb=29;function pj(b,a){b.c=a;return b;}
function rj(a){return a.a<a.c.xb();}
function sj(a){if(!rj(a)){throw new zm();}return a.c.z(a.b=a.a++);}
function tj(a){if(a.b<0){throw new ei();}a.c.ob(a.b);a.a=a.b;a.b=(-1);}
function uj(){return rj(this);}
function vj(){return sj(this);}
function oj(){}
_=oj.prototype=new mi();_.B=uj;_.eb=vj;_.Db=gn+'AbstractList$IteratorImpl';_.Cb=0;_.a=0;_.b=(-1);function ok(f,d,e){var a,b,c;for(b=tl(f.p());cm(b);){a=jb(dm(b),14);c=a.w();if(d===null?c===null:d.q(c)){if(e){em(b);}return a;}}return null;}
function pk(b){var a;a=b.p();return ak(new Fj(),b,a);}
function qk(a){return ok(this,a,false)!==null;}
function rk(d){var a,b,c,e,f,g,h;if(d===this){return true;}if(!kb(d,13)){return false;}f=jb(d,13);c=pk(this);e=f.cb();if(!xk(c,e)){return false;}for(a=ck(c);jk(a);){b=kk(a);h=this.A(b);g=f.A(b);if(h===null?g!==null:!h.q(g)){return false;}}return true;}
function sk(b){var a;a=ok(this,b,false);return a===null?null:a.y();}
function tk(){var a,b,c;b=0;for(c=tl(this.p());cm(c);){a=jb(dm(c),14);b+=a.C();}return b;}
function uk(){return pk(this);}
function Ej(){}
_=Ej.prototype=new mi();_.j=qk;_.q=rk;_.A=sk;_.C=tk;_.cb=uk;_.Db=gn+'AbstractMap';_.Cb=30;function xk(e,b){var a,c,d;if(b===e){return true;}if(!kb(b,15)){return false;}c=jb(b,15);if(c.xb()!=e.xb()){return false;}for(a=c.bb();a.B();){d=a.eb();if(!e.k(d)){return false;}}return true;}
function yk(a){return xk(this,a);}
function zk(){var a,b,c;a=0;for(b=this.bb();b.B();){c=b.eb();if(c!==null){a+=c.C();}}return a;}
function vk(){}
_=vk.prototype=new ij();_.q=yk;_.C=zk;_.Db=gn+'AbstractSet';_.Cb=31;function ak(b,a,c){b.a=a;b.b=c;return b;}
function ck(b){var a;a=tl(b.b);return hk(new gk(),b,a);}
function dk(a){return this.a.j(a);}
function ek(){return ck(this);}
function fk(){return this.b.a.a;}
function Fj(){}
_=Fj.prototype=new vk();_.k=dk;_.bb=ek;_.xb=fk;_.Db=gn+'AbstractMap$1';_.Cb=32;function hk(b,a,c){b.a=c;return b;}
function jk(a){return cm(a.a);}
function kk(b){var a;a=jb(dm(b.a),14);return a.w();}
function lk(){return jk(this);}
function mk(){return kk(this);}
function gk(){}
_=gk.prototype=new mi();_.B=lk;_.eb=mk;_.Db=gn+'AbstractMap$2';_.Cb=0;function hm(a){a.ab();return a;}
function im(c,b,a){c.e(b,a,1);}
function km(a){var b;b=Bk(new Ak());im(a,b,a.b);return b;}
function lm(k,h,l){var b=0;var c=1;var a=2;var j=this.b;for(var f in h){var e=null;if(f=='null'||f.charAt(f.length-1)=='S'){var i=null;if(l!=c&&f!='null'){i=f.substring(0,f.length-1);}if(l==b){e=i;}else if(l==c){e=j[f];}else if(l==a){e=om(i,j[f]);}k.g(e);}else{var d=j[f];for(var g in d){if(l!=a){e=d[g][l];}else{e=om(d[g][0],d[g][1]);}k.g(e);}}}}
function mm(a){if(kb(a,11)){return jb(a,11)+'S';}else if(a===null){return 'null';}else{return null;}}
function nm(b){var a=mm(b);if(a==null){var c=qm(this,b);return c!=null;}else{return this.b[a]!==undefined;}}
function om(a,b){return yl(new xl(),a,b);}
function pm(){return rl(new ql(),this);}
function qm(h,f){var a=0;var g=h.b;var e=f.C();var c=g[e];if(c!=null){for(var d in c){var b=c[d];if(b[a].q(f)){return [e,d];}}}return null;}
function rm(g){var a=0;var b=1;var f=mm(g);if(f!=null){var d=this.b[f];if(d===undefined){return null;}else{return d;}}else{f=g.C();}var c=this.b[f];if(c==null){return null;}for(var e in c){if(c[e][a].q(g)){return c[e][b];}}return null;}
function sm(){this.b=[];}
function tm(f,h){var a=0;var b=1;var g=null;var e=mm(f);if(e!=null){g=this.b[e];this.b[e]=h;if(g===undefined){this.a++;return null;}else{return g;}}else{e=f.C();}var c=this.b[e];if(c==null){c=[];this.b[e]=c;}for(var d in c){if(c[d][a].q(f)){g=c[d][b];c[d]=[f,h];return g;}}this.a++;c[c.length]=[f,h];return null;}
function um(e){var a=1;var g=this.b;var d=mm(e);var h=null;if(d!=null){h=g[d];delete g[d];if(h!==undefined){this.a--;return h;}else{return null;}}var f=qm(this,e);if(f==null){return null;}this.a--;var b=f[0];var c=f[1];var h=g[b][c][a];g[b].splice(c,1);if(g[b].length>0){return h;}delete g[b];return h;}
function pl(){}
_=pl.prototype=new Ej();_.e=lm;_.j=nm;_.p=pm;_.A=rm;_.ab=sm;_.lb=tm;_.pb=um;_.Db=gn+'HashMap';_.Cb=33;_.a=0;_.b=null;function rl(b,a){b.a=a;return b;}
function tl(a){return am(new Fl(),a.a);}
function ul(b){var a,c,d,e;a=jb(b,14);if(a!==null){d=a.w();e=a.y();if(e!==null||this.a.j(d)){c=this.a.A(d);if(e===null){return c===null;}else{return e.q(c);}}}return false;}
function vl(){return tl(this);}
function wl(){return this.a.a;}
function ql(){}
_=ql.prototype=new vk();_.k=ul;_.bb=vl;_.xb=wl;_.Db=gn+'HashMap$1';_.Cb=34;function yl(b,a,c){b.a=a;b.b=c;return b;}
function Al(c,a,b){if(a===b){return true;}else if(a===null){return false;}else{return a.q(b);}}
function Bl(a){var b;if(kb(a,14)){b=jb(a,14);if(Al(this,this.a,b.w())&&Al(this,this.b,b.y())){return true;}}return false;}
function Cl(){return this.a;}
function Dl(){return this.b;}
function El(){var a,b;a=0;b=0;if(this.a!==null){a=this.a.C();}if(this.b!==null){b=this.b.C();}return a^b;}
function xl(){}
_=xl.prototype=new mi();_.q=Bl;_.w=Cl;_.y=Dl;_.C=El;_.Db=gn+'HashMap$EntryImpl';_.Cb=35;_.a=null;_.b=null;function am(d,c){var a,b;d.c=c;a=Bk(new Ak());d.c.e(a,d.c.b,2);b=xj(a);d.a=b;return d;}
function cm(a){return rj(a.a);}
function dm(a){a.b=sj(a.a);return a.b;}
function em(a){if(a.b===null){throw fi(new ei(),'Must call next() before remove().');}else{tj(a.a);a.c.pb(jb(a.b,14).w());}}
function fm(){return cm(this);}
function gm(){return dm(this);}
function Fl(){}
_=Fl.prototype=new mi();_.B=fm;_.eb=gm;_.Db=gn+'HashMap$EntrySetImplIterator';_.Cb=0;_.a=null;_.b=null;function zm(){}
_=zm.prototype=new qi();_.Db=gn+'NoSuchElementException';_.Cb=36;function wh(){wb(new rb());}
function gwtOnLoad(b,d,c){$moduleName=d;$moduleBase=c;if(b)try{wh();}catch(a){b(d);}else{wh();}}
var nb=[{},{2:1},{2:1},{2:1},{2:1},{1:1},{5:1},{1:1,3:1},{1:1},{4:1},{7:1,8:1,9:1,10:1},{7:1,8:1,9:1,10:1},{7:1,8:1,9:1,10:1},{7:1,8:1,9:1,10:1},{7:1,8:1,9:1,10:1},{7:1,8:1,9:1,10:1},{7:1,8:1,9:1,10:1},{12:1},{12:1},{12:1},{6:1,7:1,8:1,9:1,10:1},{4:1},{2:1},{2:1},{2:1},{2:1},{2:1},{2:1},{11:1},{2:1},{13:1},{15:1},{15:1},{13:1},{15:1},{14:1},{2:1}];if (com_google_gwt_sample_hello_Hello) {  var __gwt_initHandlers = com_google_gwt_sample_hello_Hello.__gwt_initHandlers;  com_google_gwt_sample_hello_Hello.onScriptLoad(gwtOnLoad);}})();